function q_e_ij=q_e_ij_gen(n,nn,ll,graph_,z_,beta_1,lambda_matrix,w0)

q_e_ij=z_.zer_n_by_n;

for i =1:n
    
    
    js=find(graph_(nn,ll).Gp2(i,:))';
    js_li=setdiff(js,i);
    njs=size(js_li,1);
    
    if njs==0
        q_e_ij(i,:)=z_.zer_1_by_n;
    else
        
        npi=graph_(nn,ll).nP(i);
        ldi=w0(i);
        
        for j_=1:njs
            
            term3=0;
            j=js_li(j_);
            npj=graph_(nn,ll).nP(j);
            ldj=w0(j);
            term1=any(i==graph_(nn,ll).Np{j})*(lambda_matrix(j,i)*ldi*ldj)/npj;
            term2=any(j==graph_(nn,ll).Np{i})*(lambda_matrix(i,j)*ldi*ldj)/npi;
            
            intersect_set=intersect(graph_(nn,ll).Np{i},graph_(nn,ll).Np{j});
            n_intersect=size(intersect_set,2);
            
            if n_intersect==0
                term3=0;
            else
                premult=(beta_1*ldi*ldj/(npi*npj));
                for k_=1:n_intersect
                    k=intersect_set(k_);
                    term3=term3+premult*(lambda_matrix(i,k)*lambda_matrix(j,k));
                end
                
            end
            
            q_e_ij(i,j)=(term1+term2+term3);
            
        end
        
        
    end
    
    
end



end
