% Generate Graphs for Generating True Parameters along Barabasi/Users/Jacob/Dropbox/Year Five/Networks/L9/Residual Bootstrap/erdos_renyi.m-Albert.
function graph=main_ba_graph(mks,n);


  seed=17293912;    
  rng(seed,'twister')  

lam=1;         % parameter for Erdos-Renyi network used as a seed.
 S=5*ceil(sqrt(n));          % The number of the nodes in the seed network.
%S=20;
   % The number of the nodes in the graph
         
    
    % The number of the nodes in the network.
    tag=0;p=lam/(S-1);itr=0;
    while tag==0&&itr<200;
          itr=itr+1;
          seed=erdos_renyi(S,p); % Construct a Erdos-Renyi graph of size S.
  
          if size((seed>0),1)>0; % Check whether the graph is empty or not.
             tag=1;
          end
    end
            
    seed=seed-diag(diag(seed)); % The diagonal terms are set to be zero.
    graph=barabasi_albert(n,mks,seed); % Generate a graph from Barabasi-Albert
                                             % the graph is in the form of an adjacency matrix.     
end
