function out = W_gen(n,nn,graph_,z_,ll,beta);

Np=graph_(nn,ll).Np;
Npb=graph_(nn,ll).Npb;
nP=graph_(nn,ll).nP;
nPb=graph_(nn,ll).nPb;
Gp2b=graph_(nn,ll).Gp2b;
Gpb=graph_(nn,ll).Gpb;
ones_=ones(n,1);
zer_=z_.zer_n_by_1;
zer_mat=z_.zer_n_by_n;
        

out=lambda_gen_sims_2019(n,nn,ll,graph_,z_,beta);
lambda_matrix_np=out{1};
lambda_bars=out{2};


w0 = ones_+beta^2*lambda_bars./(nP-beta^2*lambda_bars);
w0(isnan(w0))=0; %Because empty payoff neighborhood
wij0s=beta*lambda_matrix_np.*(w0*ones(1,n));

W_simple_mat=zer_mat;
W_fo=zer_mat;
W_bar=zer_mat;


for i =1:n
    for j_=1:nPb(i)      %Consider each of i's payoff neighbors
        j=Npb{i}(j_);    %Extract the actual index associated with this #'d of i'd payoff neighbord
        W_simple_mat(j,i)= (j==i)*w0(i)+wij0s(i,j)*(any(j==Np{i}));
    end
end




for i =1:n
    sumz=zer_;
    sumz2=zer_;
    sumi=0;

    for k_=1:nP(i)
        k=Np{i}(k_);
        sumz=sumz+(beta/nP(i))*(W_simple_mat(:,k).*Gpb(:,k));
        sumi=sumi+(beta/nP(i))*(W_simple_mat(i,k));        
        sumz2=sumz2+(1/nP(i))*(W_simple_mat(:,k).*Gpb(:,k));
    end
    
    sumz(i)=1+sumi;
    W_fo(:,i)=sumz;
    W_bar(:,i)=sumz2;
end

W_fo_mat=(W_fo.*Gp2b)';
W_bar_mat=(W_bar.*Gp2b)';
out={W_fo_mat,W_bar_mat};

end