
function stat_out=stats_asymptotic_fos(nn,ll,graph_,Ys,phi_tilde,Z_beta,q_e_ij_s,ar_);


matrix=ar_.zeros_mm;
for i =1:ar_.n
    matrix_=ar_.zeros_mm;
    phitimes=phi_tilde(i,:)';
    for j_=1:graph_(nn,ll).nP4_tilde(i)
        j=graph_(nn,ll).Np4_tilde{i}(j_);  
        matrix_=matrix_+q_e_ij_s(i,j)*phitimes*phi_tilde(j,:);
    end  
     matrix=matrix+matrix_;
end
% keyboard

l2term2=matrix;
% toc

%% Construct The Test Statistic

% Part 1. Construct Lambda_hat

%a) First, we construct v_hat
s_phi_z=phi_tilde'*Z_beta/ar_.n;
s_phi_z_t=s_phi_z';
a_0=s_phi_z_t;
s_phi_y=phi_tilde'*Ys/ar_.n;
rho_tilde=(a_0*s_phi_z)\a_0*s_phi_y;
vtilde=Ys-Z_beta*rho_tilde;

lambda_1_hat=phi_tilde'*(phi_tilde.*(vtilde.^2*ar_.om))/ar_.n;

term2=graph_(nn,ll).Gp*vtilde;
vde=vtilde.*term2;
s_hat_numer=sum(vde);

%b) ii. S_hat_denominator    
% sqrthihj=hsqrt*hsqrt';
q_e_bar_i=(sum(graph_(nn,ll).Gp.*q_e_ij_s,2));
s_hat_denom=sum(q_e_bar_i);

%b) iii. S_hat: 

% keyboard

s_hat=s_hat_numer/s_hat_denom;


lambda_2_hat=(s_hat/ar_.n)*l2term2;


%This is lambda
 
lambda_hat=(lambda_1_hat+lambda_2_hat);
 
 %Adjustment as in Cameron, Gelbach, Miller (2011). 
 if min(eig(lambda_hat))<=0
     [B_mat,A_mat] =eig(lambda_hat);
     A_tilde=diag(max(diag(A_mat),0.005));
     lambda_hat=B_mat*A_tilde*B_mat';
 else
 end
 
 
a_ss=s_phi_z_t/lambda_hat;

rho_hat=(a_ss*s_phi_z)\a_ss*s_phi_y;
vhat=Ys-Z_beta*rho_hat;

%Inference on beta
prod_1=phi_tilde'*vhat;
T=prod_1'*(lambda_hat\prod_1)/ar_.n;


%Inference on a'rho

sig_hat_sq=((ar_.a_vec)'/(a_ss*s_phi_z))*ar_.a_vec;


c_rho_term=ar_.critval_rho*sqrt(sig_hat_sq)/ar_.sqrtn;
C_hat_rho=[ar_.a_vec'*rho_hat-c_rho_term,ar_.a_vec'*rho_hat+c_rho_term];


term_vhat=graph_(nn,ll).Gp*vhat;
vde_hat=vhat.*term_vhat;
parentheses=sum(vde_hat);
dav_Star=sqrt(mean(graph_(nn,ll).nP));
avqvhat=sum(vhat.^2)/ar_.n;
S1_hat_sq_Beta=dav_Star*(avqvhat);
IU=(parentheses^2)/(2*ar_.n*S1_hat_sq_Beta^2);


stat_out={T,C_hat_rho,IU};



end
