    
function graphdata=graph_generate(lam,n,gtype);


if gtype==1;
    Gp_=full(erdos_renyi(n,lam/n));
else if gtype==0;
        m0=lam;
        Gp_=double(main_ba_graph(m0,n));
    end
end

nP_=zeros(n,1);
nP_2=zeros(n,1);
Np_=cell(n,1);
Np_2=cell(n,1);
Gp_2=(Gp_+Gp_*Gp_)>0;   
lhat2Neighbors=cell(n,1);
lamhat2graph=(Gp_*Gp_)>0;
for i=1:n
   lamhat2graph(i,i)=0;    %This is used in the construction of asymptotic covariance matrix (Lambda_2)
end
nPlh2=sum(lamhat2graph,2);
    
for j =1:n
    Np_{j}=find(Gp_(j,:));
    nP_(j)=size(Np_{j},2);  %number of Np neighbors
    Np_2{j}=setdiff(find(Gp_2(j,:)),j); %Exclude j.
    nP_2(j)=size(Np_2{j},2);
    lhat2Neighbors{j}=find(lamhat2graph(j,:));
end

graphdata={Gp_,Np_,nP_,Gp_2,Np_2,nP_2,lamhat2graph,lhat2Neighbors,nPlh2};
end